/* Copyright (C) 1998 Oregon Graduate Institute of Science & Technology
 * Portions copyright (c) 1995 Brown University.
 * Copyright (c) 1995 The Regents of the University of California.
 * 
 * See the file COPYRIGHT, which should have been supplied with this
 * package, for licensing details.  We may be contacted through email
 * at <quasar-help@cse.ogi.edu>.
 */

#ifndef GDITH_H
#define GDITH_H

#include "global.h"
#include "video.h"

/* gdith.c */
extern int InitDithering(void);
extern PictImage *DoDitherImage(VidDecoder *vid_decoder, GtkWidget *render);
extern void Twox2Color16DitherImage(unsigned char *lum, unsigned char *cr , 
				    unsigned char *cb , unsigned char *out , 
				    int rows , int cols);
extern void Twox2Color32DitherImage(unsigned char *lum, unsigned char *cr , 
				     unsigned char *cb , unsigned char *out , 
				     int rows , int cols);

/* fs2.c */
void InitFS2Dither(void);
void FS2DitherImage(unsigned char *lum, unsigned char *cr , unsigned char *cb , 
		    unsigned char *disp , int rows , int cols);

/* fs2fast.c */
void InitFS2FastDither(void);
void FS2FastDitherImage(unsigned char *lum, unsigned char *cr , unsigned char *cb, 
			unsigned char *out , int h , int w);

/* fs4.c */
void InitFS4Dither(void);
void FS4DitherImage(unsigned char *lum, unsigned char *cr , unsigned char *cb, 
		    unsigned char *disp , int rows , int cols);

/* hybrid.c */
void InitHybridDither(void);
void HybridDitherImage(unsigned char *lum, unsigned char *cr , 
		       unsigned char *cb , unsigned char *out , int h , int w);

/* hybriderr.c */
void InitHybridErrorDither(void);
void HybridErrorDitherImage(unsigned char *lum, unsigned char *cr , 
			    unsigned char *cb , unsigned char *out , int h , int w);

/* 2x2.c */
void Init2x2Dither(void);
void RandInit(int h, int w);
void PostInit2x2Dither(void);
void Twox2DitherImage(unsigned char *lum, unsigned char *cr , unsigned char *cb , 
		      unsigned char *out , int h , int w);

/* gray.c */
void GrayDitherImage(unsigned char *lum, unsigned char *cr , unsigned char *cb , unsigned char *out , int h , int w);
void Gray2DitherImage(unsigned char *lum, unsigned char *cr , unsigned char *cb , unsigned char *out , int h , int w);
void Gray16DitherImage(unsigned char *lum, unsigned char *cr , unsigned char *cb , unsigned char *out , int h , int w);
void Gray216DitherImage(unsigned char *lum, unsigned char *cr , unsigned char *cb , unsigned char *out , int h , int w);
void Gray32DitherImage(unsigned char *lum, unsigned char *cr , unsigned char *cb , unsigned char *out , int h , int w);
void Gray232DitherImage(unsigned char *lum, unsigned char *cr , unsigned char *cb , unsigned char *out , int h , int w);

/* 16bit.c */
void InitColorDither(GdkVisual *visual);
void Color16DitherImage(unsigned char *lum, unsigned char *cr , unsigned char *cb , unsigned char *out , int rows , int cols);
void Color32DitherImage(unsigned char *lum, unsigned char *cr , unsigned char *cb , unsigned char *out , int rows , int cols);

/* ordered.c */
void InitOrderedDither(void);
void OrderedDitherImage(unsigned char *lum, unsigned char *cr , unsigned char *cb , unsigned char *out , int h , int w);

/* ordered2.c */
void InitOrdered2Dither(void);
void Ordered2DitherImage(unsigned char *lum, unsigned char *cr , unsigned char *cb , unsigned char *out , int h , int w);

/* mb_ordered.c */
void InitMBOrderedDither(void);
void MBOrderedDitherImage(unsigned char *lum, unsigned char *cr , unsigned char *cb , unsigned char *out , int h , int w, char *ditherFlags);
void MBOrderedDitherDisplayCopy(VidDecoder *vid_decoder, int mb_addr , int motion_forw , int r_right_forw , int r_down_forw , int motion_back , int r_right_back , int r_down_back , unsigned char *past , unsigned char *future);

#endif /* GDITH_H */
