#include "global.h"
#include "video.h"
#include "util.h"
#include "gdith.h"
#include "stream_play.h"

#include <streamer/streamer.h>
#include <mpeg.h>
#include "common.h"

StreamElementType *_mpeg;

StreamElement *Stream_mpeg_create() {
  Stream_mpeg *element;

  element = (Stream_mpeg *)malloc(sizeof(Stream_mpeg));

  element->element.flags = 0;
  element->element.inpadfunc = NULL; /* lave it up to the general case */
  element->element.outpadfunc = NULL; /* ditto */
  element->element.chain = Stream_mpeg_chain;
  element->element.push = NULL;
  element->element.inpads = NULL;
  element->element.outpads = NULL;

  /* construct the input pad */
  element->in.type = 0;
  element->in.flags = 0;
  element->in.owner = (StreamElement *)element;
  element->in.peer = NULL;
  element->in.chain = Stream_mpeg_chain;
  DEBUG("mpeg set chain to %p\n",element->in.chain);
  /* register it */
  element->element.inpads =
    g_slist_append(element->element.inpads,&element->in);

  element->out.type = 0;
  element->out.flags = 0;
  element->out.owner = (StreamElement *)element;
  element->out.peer = NULL;
  element->out.chain = NULL;
  /* register it */
  element->element.outpads =
    g_slist_append(element->element.outpads,&element->out);

  /* now actually do the MPEG-specific initialization */
  InitEverything();
  element.Source = NewDataStream(unsigned int)

  return (StreamElement *)element;
}

void Stream_mpeg_chain(StreamPad *pad,StreamBuffer *buf) {
  Stream_mpeg *mpeg_element = (Stream_mpeg *)pad->owner;

  
}


void init_StreamPlugin(StreamPlugin *plugin) {
  /* we have to do this because we're going to return static data */
  g_module_make_resident(plugin->module);

  /* fill in the StreamPlugin data */
  plugin->name = "mpeg_video";
  plugin->longname = "MPEG Video decoder";
  plugin->version = "0.0.0";
  plugin->elementtypes = NULL;
  plugin->enumtypes = NULL; /* simple case, we rely on default */

  /* now create the element type */
  _mpeg = (StreamElementType *)g_malloc(sizeof(StreamElementType));
  _mpeg->plugin = plugin;
  _mpeg->name = "mpeg_video";
  _mpeg->longname = "MPEG Video decoder";
  _mpeg->version = "0.0.0";
  _mpeg->create = Stream_mpeg_create;

  /* add it to the necessary lists */
  plugin->elementtypes = g_slist_append(plugin->elementtypes,_mpeg);
  StreamElementType_register(_mpeg);

  /* announce that we're here... */
  DEBUG("initialized plugin '%s'\n",StreamPlugin_getname(plugin));
}
